//    Copyright 2025 Bill Rossi
//    
//    This file is part of Starship Futuretime
//
//    Starship Futuretime is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//    Starship Futuretime is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with Starship Futuretime. If not, see <https://www.gnu.org/licenses/>. 
#ifndef BULLET_H
#define BULLET_H
#include <raylib.h>

#include "entity.h"
#include "game.h"

typedef struct BulletProperties {
  Rectangle position;
  Vector2 velocity;
  bool from_enemy;
} BulletProperties;

Entity *spawn_bullet(Vector2 spawn_at, Vector2 velocity, bool from_enemy);
void draw_bullet(Entity *e);
void tick_bullet(Game *g, Entity *e, float dt);
void free_bullet(Entity *e);

#endif
